
SnapML MPI framework can be plugged into Deep Learning Impact(DLI) using the set of files provided in this directory.

If DLI is already installed in a cluster environment, identify the management host and compute hosts and run the provided script `dli_install_snapml` to install the necessary files into respective directories. This script is expected to be run as root user.

# $CONDA_PREFIX/pai4sk/dli_scripts/dli_install_snapml

For the above script to succeed in a management host, the following environmental variables should be set,

* EGO_TOP :  installation directory of IBM spectrum computing
* DLI_SHARED_FS : Deep Learning Impact's shared filesystem used during installation.
* CLUSTERADMIN : User with CwS cluster administrative privileges
* ADMINGROUP : Group with CwS cluster administrative privileges

On completion, you should see the SnapML framework listed as part of the supported frameworks,

python dlicmd.py --dl-frameworks --master-host $masterHost

A new Spark Instance Group(SIG) is required to be created in Conductor with Spark. Details related to creating the SIG can be found in a blog: https://developer.ibm.com/linuxonpower/2018/06/25/running-distributed-deep-learning-tasks-ibm-powerai-enterprise-1-1/

Once a SIG is created, to submit a SnapML Job to the DLI cluster from CLI run,

python dlicmd.py --exec-start snapML --exclusive --master-host <masterHost> --ig <ig>
    --numWorker 4 --mpiarg --allow-run-as-root python 
    --model-main $CONDA_PREFIX/pai4sk/mpi-examples/example-criteo/example-criteo.py
    --use_gpu 
Here we have used one of the examples `example-criteo.py` which is shipped with PowerAI base package. Details related to how to run this example and its related dataset can be found under $CONDA_PREFIX/pai4sk/mpi-examples/README.md.

More information on Deep Learning Impact and Watson Machine Learning Accelerator can be found under https://www.ibm.com/support/knowledgecenter/en/SSFHA8

&copy; Copyright IBM Corporation 2018, 2019
