Download the criteo data and create a training set consisting of the 1st billion examples:
```
mkdir data
cd data
wget https://s3-us-west-2.amazonaws.com/criteo-public-svm-data/criteo_tb.svm.tar.gz
tar xzf criteo_tb.svm.tar.gz
head -c 583222144041 criteo_tb > criteo_tb_1b
cd ../
```

Convert the data to Snap ML binary format using 40 cores:
```
mpirun --use-hwthread-cpus -n 40 python preprocess-criteo-tb.py
```

On an AC922 server, the following time is reported:
```
Time to pre-process training data (s): 350.529193
Time to pre-process test data (s): 277.126420
```
Pre-processing time will vary depending on system configuration and state of buffer cache.

Train a logistic regression model on the tera-scale dataset using all avaliable CPUs + GPUs:

```
snaprun python example-criteo-tb.py
```

On an AC922 server with four 32GB V100 GPUs the following output is obtaind:

```
+ mpirun -x PATH -x LD_LIBRARY_PATH -x DLI_SNAPML_MPI=1 --rankfile /tmp/SNAPRUN/snaprun.ByIvFOzWztAw/RANKFILE -n 4 python example-criteo-tb.py
Time to load training data (s): 12.434778
Time to load test data (s): 2.132895
[Info] Tolerance 0.001 attained after 105 epochs.
Training time (s): 74.198679
Logistic Loss: 0.130245
```

Data loading time will vary depending on system configuration and state of buffer cache. 
Training time will vary depending on system configuration.

&copy; Copyright IBM Corporation 2019, 2020
